LeetCode-Lowest Common Ancestor of a Binary Search Tree-解题报告

原题链接 https://leetcode.com/problems/lowest-common-ancestor-of-a-binary-search-tree/

Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.

According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes v and w as the lowest node in T that has both v and w as descendants (where we allow a node to be a descendant of itself).”

        _______6______
       /              \
    ___2__          ___8__
   /      \        /      \
   0      _4       7       9
         /  \
         3   5

For example, the lowest common ancestor (LCA) of nodes 2 and 8 is 6. Another example is LCA of nodes 2 and 4 is 2, since a node can be a descendant of itself according to the LCA definition.


找到最近公共祖先


我使用两个hash表。

首先如果把root所在节点标记为1则,他的左儿子标记为2,右儿子标记为3,对于一个标记为x的节点,他的左儿子为x*2,右儿子为x*2+1;


所以我通过hash表PtoT,用标记映射地址。

另一个hash表VtoP,用值来映射标记。

当然可能存在相等的元素,因此我只记录最小的标记。

得到p和q的标记后,表可以将p和q中标记最大的除以2,直到p和q相等结束。

然后用Ptov[p]返回即可。

当然程序是可以优化的,可以在找到两个元素后便返回,不用记录所有点。

空间也可以进一步优化,只记录PtoT,而两个元素的标记在dfs的记录下来。


class Solution {
public:
	TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {
		dfs(root, 1);
		int pp = VtoP[p->val];
		int pq = VtoP[q->val];
		while (pp != pq)
		{
			if (pp > pq)pp >>= 1;
			else pq >>= 1;
		}
		return PtoT[pp];
	}
	void dfs(TreeNode* root, int pos)
	{
		if (root == NULL)return;
		if (PtoT.find(pos) == PtoT.end())
		{
			PtoT[pos] = root;
			VtoP[root->val] = pos;
		}
		pos <<= 1;
		dfs(root->left, pos);
		dfs(root->right, pos + 1);
	}
private:
	unordered_map<int, TreeNode*>PtoT;
	unordered_map<int, int>VtoP;
};


 

發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章